<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');
jimport('joomla.plugin.plugin');
class plgContentEDocmanCategory extends JPlugin
{
    /**
     * Method is called by the view
     *
     * @param    object        The article object.  Note $article->text is also available
     * @param    object        The article params
     * @param    int            The 'page' number
     */
    function onContentPrepare($context, &$article, &$params, $limitstart)
    {
        error_reporting(0);
        $app = JFactory::getApplication();
        if ($app->getName() != 'site') {
            return true;
        }
        if (strpos($article->text, 'edocmancategory') === false) {
            return true;
        }
        $regex = "#{edocmancategory (\d+)}#s";
        $article->text = preg_replace_callback($regex, array(&$this, '_renderEDocmanCategory'), $article->text);
        return true;
    }

    /**
     * Replace the text with the event detail
     *
     * @param array $matches
     */
    function _renderEDocmanCategory(&$matches)
    {
        error_reporting(0);
        $document = JFactory::getDocument();
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        JLoader::register('EDocmanModelCategory', JPATH_ROOT.'/components/com_edocman/models/category.php');
        require_once JPATH_ADMINISTRATOR.'/components/com_edocman/libraries/rad/bootstrap.php';
        require_once JPATH_ADMINISTRATOR . '/components/com_edocman/helpers/edocman.php';
        EdocmanHelper::loadLanguage();
        $document->addStyleSheet(JURI::base(true) . '/components/com_edocman/assets/css/style.css');
        $config = EDocmanHelper::getConfig();
        if ($config->load_twitter_bootstrap !== '0')
        {
            EdocmanHelper::loadBootstrap(false);
        }
        $categoryId = (int)$matches[1];
        $query->select('*')
            ->from('#__edocman_categories')
            ->where('id='.$categoryId);
        $db->setQuery($query);
        $category = $db->loadObject();
        $items = RADModel::getInstance('Category', 'EDocmanModel')
            ->id($categoryId)
            ->limitstart(0)
            ->limit(0)
            ->getData();
        if ($config->process_plugin && count($items))
        {
            foreach ($items as $item)
            {
                $item->short_description = JHtml::_('content.prepare', $item->short_description);
            }
        }

        if ($config->show_view_button && count($items))
        {
            $extsForView = explode(',', $config->exts_for_view);
            for ($i = 0, $n = count($extsForView); $i < $n; $i++)
            {
                $extsForView[$i] = strtolower(trim($extsForView[$i]));
            }
            foreach ($items as $item)
            {
                $fileName = $item->filename;
                $fileExt = strtolower(JFile::getExt($fileName));
                if (in_array($fileExt, $extsForView))
                {
                    $item->canView = 1;
                }
                else
                {
                    $item->canView = 0;
                }
            }
        }
        if ($category->category_layout == 'table')
        {
            $layout = 'common/documents_table.php';
        }
        else
        {
            $layout = 'common/documents_default.php';
        }

        if (count($items))
        {
            return '<div class="clearfix"></div>'.EDocmanHelperHtml::loadCommonLayout($layout, array('items' => $items, 'config' => $config, 'Itemid' => EdocmanHelper::getItemid(), 'category' => $category, 'categoryId' => $categoryId));
        }
        else
        {
            return null;
        }
    }
}